#ifndef Map_H
#define Map_H

#include <Bild.h>
#include <Random.h>
#include "../../../Include/KSGKlientV.h"

using namespace Framework;

struct Tile
{
	int id;
	int grad;
	int xPos;
	int yPos;
};

class Map
{
private:
	RCArray< Array< int > > *map;
	LRahmen *feld;
	Tile t;
	int score;
    int scoreCheck;
	int breite;
	int hhe;
	int geschwindigkeit;
	int neuTempo;
	double next;
	bool beendet;
	bool sr;
	bool rend;
    double gameTime;
    Datei capture;
    Critical cs;
    MinigameKlientV *klient;
    RandomGenerator *rGen;
	int ref;

public:
	// Konstruktor
	Map( MinigameKlientV *klient );
	// Destruktor
	~Map();
	// nicht constant
	void reset( Text *zOptionen );
	void doMausEreignis( MausEreignis &me );
	void doTastaturEreignis( TastaturEreignis &te );
	bool tick( double tickVal );
	void render( Bild &zRObj );
    void speichern();
	// constant
	int getScore() const;
	bool istBeendet() const;
	// Reference Counting
	Map *getThis();
	Map *release();
};

#endif